#%define BuildRoot /tmp/%{name}-%{version}
%define __spec_install_post %{nil}

%{!?RHASML:%define RHASML 0}

Summary: A web-based administration interface for Unix systems.
Name: webmin
Version: 1.330
Release: 1.2ml
Provides: %{name}-%{version}
PreReq: /bin/sh /usr/bin/perl sh-utils perl-Net-SSLeay
Requires: /bin/sh /usr/bin/perl jcode.pl
AutoReq: 0
Copyright: Freeware
Group: System/Tools
Source: http://www.webmin.com/download/%{name}-%{version}.tar.gz

Source100: webmin-miracle-theme.wbt
Source101: webmin-gnome-menu-netscape
Source102: webmin-gnome-menu-mozilla
Source103: webmin_icon.png
Source104: webmin-desktop-link
Source105: webmin-scramble.pl

Patch100: webmin-1.230-swat.cgi-miracle.patch
Patch101: webmin-swat_save.cgi-miracle.patch
Patch102: webmin-servers-lib.pl-miracle.patch
Patch103: webmin-majordomo-config-miracle.patch
Patch104: webmin-pam-miracle.patch
Patch105: webmin-setup.sh-miracle.patch
Patch106: webmin-1.230-os_list.txt-miracle.patch
Patch107: webmin-defaulttheme.patch
Patch108: webmin-1.330-delete_modules.patch
Patch109: webmin-1.320-CVE-2007-3156.patch

BuildRoot: /tmp/%{name}-%{version}
BuildArchitectures: noarch
%description
A web-based administration interface for Unix systems. Using Webmin you can
configure DNS, Samba, NFS, local/remote filesystems and more using your
web browser.

After installation, enter the URL https://localhost:10000/ into your
browser and login as root with your root password.

%prep
%setup -q -a 100

%patch100 -p1
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1
%patch107 -p1
%patch108 -p1
%patch109 -p0

%build
(find . -name '*.cgi' ; find . -name '*.pl') | perl perlpath.pl /usr/bin/perl -
rm -f mount/freebsd-mounts*
rm -f mount/openbsd-mounts*
rm -f mount/macos-mounts*
rm -f webmin-gentoo-init
rm -rf format bsdexports hpuxexports sgiexports zones rbac
chmod -R og-w .

%install
mkdir -p %{buildroot}/usr/libexec/webmin
mkdir -p %{buildroot}/etc/sysconfig/daemons
mkdir -p %{buildroot}/etc/rc.d/{rc0.d,rc1.d,rc2.d,rc3.d,rc5.d,rc6.d}
mkdir -p %{buildroot}/etc/init.d
mkdir -p %{buildroot}/etc/pam.d
cp -rp * %{buildroot}/usr/libexec/webmin
cp webmin-daemon %{buildroot}/etc/sysconfig/daemons/webmin
cp webmin-init %{buildroot}/etc/init.d/webmin
cp webmin-pam %{buildroot}/etc/pam.d/webmin
#ln -s /etc/init.d/webmin %{buildroot}/etc/rc.d/rc2.d/S99webmin
#ln -s /etc/init.d/webmin %{buildroot}/etc/rc.d/rc3.d/S99webmin
#ln -s /etc/init.d/webmin %{buildroot}/etc/rc.d/rc5.d/S99webmin
#ln -s /etc/init.d/webmin %{buildroot}/etc/rc.d/rc0.d/K10webmin
#ln -s /etc/init.d/webmin %{buildroot}/etc/rc.d/rc1.d/K10webmin
#ln -s /etc/init.d/webmin %{buildroot}/etc/rc.d/rc6.d/K10webmin
echo rpm >%{buildroot}/usr/libexec/webmin/install-type

# Add Gnome menu
install -m 755 -d %{buildroot}/etc/X11/applnk/System
%if !%{RHASML}
install -m 644 %{SOURCE101} %{buildroot}/etc/X11/applnk/System/webmin.desktop
%else
install -m 755 -d %{buildroot}/etc/X11/starthere
install -m 644 %{SOURCE102} %{buildroot}/etc/X11/applnk/System/webmin.desktop
install -m 644 %{SOURCE102} %{buildroot}/etc/X11/starthere/webmin.desktop
%endif
# Add Desktop Icon
install -m 755 -d %{buildroot}/usr/share/pixmaps
install -m 644 %{SOURCE103} %{buildroot}/usr/share/pixmaps/webmin_icon.png
install -m 755 -d %{buildroot}/usr/lib/desktop-links/
install -m 644 %{SOURCE104} %{buildroot}/usr/lib/desktop-links/webmin.links
# Install scramble.pl
install -m 744 %{SOURCE105} %{buildroot}/usr/libexec/webmin/samba/scramble.pl

# remove Japanese message file for file manager
# since java applet can't display japanese correctly.
if [ -e %{buildroot}/usr/libexec/webmin/file/lang/ja_JP.euc ]; then
	rm -f %{buildroot}/usr/libexec/webmin/file/lang/ja_JP.euc
fi

%clean
#%{rmDESTDIR}
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
/usr/libexec/webmin
/etc/sysconfig/daemons/webmin
/etc/init.d/webmin
#/etc/rc.d/rc2.d/S99webmin
#/etc/rc.d/rc3.d/S99webmin
#/etc/rc.d/rc5.d/S99webmin
#/etc/rc.d/rc0.d/K10webmin
#/etc/rc.d/rc1.d/K10webmin
#/etc/rc.d/rc6.d/K10webmin
%config /etc/pam.d/webmin
/etc/X11/applnk/System/webmin.desktop
%if %{RHASML}
/etc/X11/starthere/webmin.desktop
%endif
/usr/share/pixmaps/webmin_icon.png
/usr/lib/desktop-links/webmin.links

%pre
perl <<EOD;
# maketemp.pl
# Create the /tmp/.webmin directory if needed

\$tmp_dir = \$ENV{'tempdir'} || "/tmp/.webmin";

while(\$tries++ < 10) {
	local @st = lstat(\$tmp_dir);
	exit(0) if (\$st[4] == \$< && (-d _) && (\$st[2] & 0777) == 0755);
	if (@st) {
		unlink(\$tmp_dir) || rmdir(\$tmp_dir) ||
			system("/bin/rm -rf ".quotemeta(\$tmp_dir));
		}
	mkdir(\$tmp_dir, 0755) || next;
	chown(\$<, \$(, \$tmp_dir);
	chmod(0755, \$tmp_dir);
	}
exit(1);


EOD
if [ "$?" != "0" ]; then
	echo "Failed to create or check temp files directory /tmp/.webmin"
	exit 1
fi
perl >/tmp/.webmin/$$.check <<EOD;
\$uname = \`uname -a\`;
if (\`cat /etc/redhat-release 2>/dev/null\` =~ /(Advanced\\s+Server.*2\\.1)|(AS.*2\\.1)/i) {
	print "oscheck='Redhat Enterprise Linux'\\n";
	}
elsif (\`cat /etc/miraclelinux-release 2>&1\` =~ /2\\.0/) {
	print "oscheck='Miracle Linux 2.0'\\n";
	}
elsif (\`cat /etc/miraclelinux-release 2>&1\` =~ /2\\.1/) {
	print "oscheck='Miracle Linux 2.1'\\n";
	}

EOD
. /tmp/.webmin/$$.check
rm -f /tmp/.webmin/$$.check
if [ ! -r /etc/webmin/config ]; then
	if [ "$oscheck" = "" ]; then
		echo Unable to identify operating system
		exit 2
	fi
	echo Operating system is $oscheck
	if [ "$WEBMIN_PORT" != "" ]; then
		port=$WEBMIN_PORT
	else
		port=10000
	fi
#	perl -e 'use Socket; socket(FOO, PF_INET, SOCK_STREAM, getprotobyname("tcp")); setsockopt(FOO, SOL_SOCKET, SO_REUSEADDR, pack("l", 1)); bind(FOO, pack_sockaddr_in($ARGV[0], INADDR_ANY)) || exit(1); exit(0);' $port
	if [ "$?" != "0" ]; then
		echo Port $port is already in use
		exit 2
	fi
fi
# Save /etc/webmin in case the upgrade trashes it
if [ "$1" != 1 ]; then
	rm -rf /etc/.webmin-backup
	cp -r /etc/webmin /etc/.webmin-backup
fi

%post
/sbin/chkconfig --add webmin
inetd=`grep "^inetd=" /etc/webmin/miniserv.conf 2>/dev/null | sed -e 's/inetd=//g'`
if [ "$1" != 1 ]; then
	# Upgrading the RPM, so stop the old webmin properly
	if [ "$inetd" != "1" ]; then
		/etc/init.d/webmin stop >/dev/null 2>&1 </dev/null
	fi
fi
cd /usr/libexec/webmin
config_dir=/etc/webmin
var_dir=/var/webmin
perl=/usr/bin/perl
autoos=3
if [ "$WEBMIN_PORT" != "" ]; then
	port=$WEBMIN_PORT
else
	port=10000
fi
login=root
if [ -r /etc/shadow ]; then
	#crypt=`grep "^root:" /etc/shadow | cut -f 2 -d :`
	crypt=x
else
	crypt=`grep "^root:" /etc/passwd | cut -f 2 -d :`
fi

# Use pam for root
crypt=x
allow=localhost
host=`hostname`
ssl=1
atboot=1
nochown=1
autothird=1
noperlpath=1
nouninstall=1
nostart=1
export config_dir var_dir perl autoos port login crypt host ssl nochown autothird noperlpath nouninstall nostart allow

#save config files made by setup.sh (avoid upgrading config files)
if [ -r $config_dir/config ]; then
	/bin/mv $config_dir/config $config_dir/config.wm_rpmsave
fi
if [ -r $config_dir/miniserv.conf ]; then
	/bin/mv $config_dir/miniserv.conf $config_dir/miniserv.conf.wm_rpmsave
fi

./setup.sh >/tmp/.webmin/webmin-setup.out 2>&1
rm -f /var/lock/subsys/webmin
if [ "" != "1" ]; then
	/etc/init.d/webmin start >/dev/null 2>&1 </dev/null
fi
cat >/etc/webmin/uninstall.sh <<EOFF
#!/bin/sh
printf "Are you sure you want to uninstall Webmin? (y/n) : "
read answer
printf "\n"
if [ "\$answer" = "y" ]; then
	echo "Removing webmin RPM .."
	rpm -e --nodeps webmin
	echo "Done!"
fi
EOFF
chmod +x /etc/webmin/uninstall.sh
port=`grep "^port=" /etc/webmin/miniserv.conf | sed -e 's/port=//g'`
perl -e 'use Net::SSLeay' >/dev/null 2>/dev/null
sslmode=1
if [ "$?" = "0" ]; then
	grep ssl=1 /etc/webmin/miniserv.conf >/dev/null 2>/dev/null
	if [ "$?" = "0" ]; then
		sslmode=0
	fi
fi
if [ "$sslmode" = "0" ]; then
	echo "Webmin install complete. You can now login to https://localhost:$port/"
else
	echo "Webmin install complete. You can now login to http://localhost:$port/"
fi
echo "as root with your root password."

# Set root acl for security fix
cat >/etc/webmin/root.acl <<EOFF
rpc=0
gedit_mode=0
noconfig=
root=/
gedit=
gedit2=
feedback=2
uedit2=
uedit_mode=0
uedit=
EOFF
chmod 640 /etc/webmin/root.acl

%preun
if [ "$1" = 0 ]; then
	grep root=/usr/libexec/webmin /etc/webmin/miniserv.conf >/dev/null 2>&1
	if [ "$?" = 0 ]; then
		# RPM is being removed, and no new version of webmin
		# has taken it's place. Run uninstalls and stop the server
		echo "Running uninstall scripts .."
		(cd /usr/libexec/webmin ; WEBMIN_CONFIG=/etc/webmin WEBMIN_VAR=/var/webmin LANG= /usr/libexec/webmin/run-uninstalls.pl)
		/etc/init.d/webmin stop >/dev/null 2>&1 </dev/null
		/etc/webmin/stop >/dev/null 2>&1 </dev/null
		/sbin/chkconfig --del webmin
		/bin/true
	fi
fi

%postun
if [ "$1" = 0 ]; then
	grep root=/usr/libexec/webmin /etc/webmin/miniserv.conf >/dev/null 2>&1
	if [ "$?" = 0 ]; then
		# RPM is being removed, and no new version of webmin
		# has taken it's place. Delete the config files
		rm -rf /etc/webmin /var/webmin
	fi
fi

%triggerpostun -- webmin
if [ ! -d /var/webmin -a "$1" = 2 ]; then
	echo Re-creating /var/webmin directory
	mkdir /var/webmin
fi
if [ ! -r /etc/webmin/miniserv.conf -a -d /etc/.webmin-backup -a "$1" = 2 ]; then
	echo Recovering /etc/webmin directory
	rm -rf /etc/.webmin-broken
	mv /etc/webmin /etc/.webmin-broken
	mv /etc/.webmin-backup /etc/webmin
	/etc/init.d/webmin stop >/dev/null 2>&1 </dev/null
	/etc/init.d/webmin start >/dev/null 2>&1 </dev/null
else
	rm -rf /etc/.webmin-backup
fi

%changelog
* Thu Oct 15 2009 Ryoji Kamei <kamei@miraclelinux.com> 1.330-1.2ml
- fix CVE-2007-3156

* Fri Mar 30 2007 Ryoji Kamei <kamei@miraclelinux.com> 1.330-1.1ml
- upgrade to 1.330-1 for fixing security holes

* Wed Oct  5 2005 Shiro Yamada <shiro@miraclelinux.com> 1.230-1.2ml
- upgrade to 1.230-1

* Mon Jun 21 2004 Shiro Yamada <shiro@miraclelinux.com> 1.150-1.1ml
- upgrade the base to 1.150 for security fixes

* Wed May 28 2003 Yuji Oishi <yoishi@miraclelinux.com>
- delete Vendor tag.
- add RHASML flag setting
- add webmin-gnome-menu-netscape and webmin-gnome-menu-mozilla.
- add webmin_icon.png.
- add webmin-desktop-link.
- add scramble.pl.
- add patch webmin-swat.cgi-miracle.patch.
- add patch webmin-swat_save.cgi-miracle.patch.
- add patch webmin-servers-lib.pl-miracle.patch.
- add patch webmin-majordomo-config-miracle.patch.
- add patch webmin-pam-miracle.patch.
- add "allow=localhost" to forbid remote access in spec file.
- add "export crypt(=x)" in spec file.
- change the description such as "http://localhost:10000" to "https://...." in
  spec file.
- add "sh-utils perl-Net-SSLeay" on PreReq, "jcode.pl" on Requires.
- save config files(config, miniserv.conf) as *.wm_rpmsave when updating
  in spec file
- remove file/lang/ja_JP.euc since java applet can't show Japanese.
- add miraclelinux-release checking line in spec file.
- delete making link in /etc/rc.d/rc*.d, execute chkconfig instead.
- add patch webmin-setup.sh-miracle.patch
- add patch os_list.txt-miracle.patch.
- add patch apache-config-redhat-linux-7.1.patch.
- delete modules which don't work on Miracle Linux
- create root.acl file to fix security problem
